"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfusableMatcherInterop = exports.EReturnStatus = void 0;
var EReturnStatus;
(function (EReturnStatus) {
    EReturnStatus[EReturnStatus["MATCH"] = 0] = "MATCH";
    EReturnStatus[EReturnStatus["NO_MATCH"] = 1] = "NO_MATCH";
    EReturnStatus[EReturnStatus["TIMEOUT"] = 2] = "TIMEOUT";
    EReturnStatus[EReturnStatus["WORD_BOUNDARY_FAIL_START"] = 3] = "WORD_BOUNDARY_FAIL_START";
    EReturnStatus[EReturnStatus["WORD_BOUNDARY_FAIL_END"] = 4] = "WORD_BOUNDARY_FAIL_END";
})(EReturnStatus = exports.EReturnStatus || (exports.EReturnStatus = {}));
let classExport;
exports.ConfusableMatcherInterop = classExport;
const ADDON_PATHS = [
    '../Debug/confusablematcher-js-interop-native',
    '../build/Debug/confusablematcher-js-interop-native',
    '../Release/confusablematcher-js-interop-native',
    '../build/Release/confusablematcher-js-interop-native',
];
for (const path of ADDON_PATHS) {
    try {
        const module = require(path);
        exports.ConfusableMatcherInterop = classExport = module.ConfusableMatcher;
        break;
    }
    catch (e) {
        if ((e === null || e === void 0 ? void 0 : e.code) !== 'MODULE_NOT_FOUND') {
            throw e;
        }
    }
}
exports.default = classExport;
//# sourceMappingURL=binding.js.map