/*********************************************************************************
 * This file is part of CUTE.
 *
 * Copyright (c) 2006-2018 Peter Sommerlad, IFS
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 *********************************************************************************/

#include "cute_test.h"

#include "test_cute_test.h"
#include "cute_equals.h"

namespace for_cute_equals_test {
struct Test{
	void operator()(){}
};
void aTestFunction(){
}
}
namespace {
void test_cute_macro(){
	using namespace for_cute_equals_test;
	cute::test t = CUTE(aTestFunction);
	ASSERT_EQUAL("aTestFunction",t.name());
}
void test_functor(){
	cute::test t = for_cute_equals_test::Test();
	std::string typesuffix= "for_cute_equals_test::Test";
	ASSERT_EQUAL(typesuffix,t.name().substr(t.name().size()-typesuffix.size()));
}
}
cute::suite test_cute_test(){
	cute::suite s;
	s.push_back( CUTE(test_cute_macro));
	s.push_back(CUTE(test_functor));
	return s;
}
